#i main.tcl

#!/bin/sh
# the next line restarts using wish \
exec wish4.0 "$0" "$@"

eval destroy [winfo child .]
wm title . "GALOPPS"

global env

source $env(GALOPPS_GUI_HOME)/help.tcl

#----------------------------------------------------------------
# The code below create the main window
#----------------------------------------------------------------


global sorted_list {}
global current_path
global input_fileName

set font -*-Helvetica-Medium-R-Normal--*-140-*-*-*-*-*-*
set font1 -*-Helvetica-Medium-R-Normal--*-100-*-*-*-*-*-*

#set current_dir [exec pwd]
#puts stdout $current_dir

frame .menuBar
pack .menuBar -side top -fill x


button .menuBar.exit -text Exit -command "exit"
button .menuBar.open -text Open -command {source $env(GALOPPS_GUI_HOME)\/open.tcl}

set Input1 "Onepop
   Input"
set Input2 "Manypop
   Input"
button .menuBar.input1  -text $Input1 -command {source $env(GALOPPS_GUI_HOME)\/input1.tcl}
button .menuBar.input2  -text $Input2 -command {
        source $env(GALOPPS_GUI_HOME)\/input2.tcl
        source $env(GALOPPS_GUI_HOME)\/relation.tcl
	}
button .menuBar.output -text Output -command {source $env(GALOPPS_GUI_HOME)\/output.tcl}
button .menuBar.display -text Display -command {source $env(GALOPPS_GUI_HOME)\/plot.tcl}
button .menuBar.run -text Run -command {
  source $env(GALOPPS_GUI_HOME)\/run.tcl
}

catch {image delete image1bc}
image create photo image1bc -file $env(GALOPPS_GUI_HOME)\/garage.gif
label .menuBar.photo -image image1bc
pack .menuBar.exit .menuBar.open .menuBar.input1 .menuBar.input2 \
     .menuBar.output .menuBar.display .menuBar.run .menuBar.photo \
     -side left -fill x -expand 1

scrollbar .s -orient vertical -command {.t yview}
pack .s -side right -fill y
text .t -yscrollcommand {.s set} -wrap word -width 60 -height 25 -font $font \
	-setgrid 1
pack .t -expand y -fill both

# Create a bunch of tags to use in the text widget, such as those for
# section titles and demo descriptions.  Also define the bindings for
# tags.

.t tag configure title -font -*-Helvetica-Bold-R-Normal--*-180-*-*-*-*-*-*
.t tag configure demo -lmargin1 1c -lmargin2 1c
if {[winfo depth .] == 1} {
    .t tag configure hot -background black -foreground white
} else {
    .t tag configure hot -relief raised -borderwidth 1 -background SeaGreen3
}
.t tag bind demo <Button-1> {
    invoke [.t index current]
}
set lastLine ""
.t tag bind demo <Enter> {
    set lastLine [.t index {@%x,%y linestart}]
    .t tag add hot $lastLine "$lastLine lineend"
}
.t tag bind demo <Leave> {
    .t tag remove hot 1.0 end
}
.t tag bind demo <Motion> {
    set newLine [.t index {@%x,%y linestart}]
    if {[string compare $newLine $lastLine] != 0} {
	.t tag remove hot 1.0 end
	set lastLine $newLine
	.t tag add hot $lastLine "$lastLine lineend"
    }
}

# Create the text for the text widget.

.t insert end "                                 GALOPPS\n" title
.t insert end {
                             The Genetic Algorithm Optimized
	                                   for 
                             Portability and Parallelism" System
                                  Release 3.2(July 16, 1996
                                   GENETIC ALGORITHMS
               RESEARCH AND APPLICATIONS GROUP(GARAGe)
                       INTELLIGENT SYSTEMS LABORATORY,
                       DEPARTMENT OF COMPUTER SCIENCE
                                                 AND
                       CASE CENTER FOR COMPUTER-AIDED
                       ENGINEERING AND MANUFACTURING
	 
                   MICHIGAN STATE UNIVERSITY, EAST LANSING
}
.t insert end \n {} "About Galopps\n" title
.t insert end "1. Readme\n" {demo demo-t1}
.t insert end "2. No Warranty\n" {demo demo-t2} 
.t insert end "3. Heredity\n" {demo demo-t3}
.t insert end "4. License\n" {demo demo-t4} 
.t insert end "5. Author\n" {demo demo-author}

.t configure -state disabled

# positionWindow --
# This procedure is invoked by most of the sources to position a
# new window.
proc positionWindow w {
  wm geometry $w +300+300
}

proc positionWindow1 w {
  wm geometry $w +120+30
}

proc positionWindow2 w {
    wm geometry $w +580+5
}

proc positionWindow3 w {
    wm geometry $w +40+200
    }

proc positionWindow4 w {
    wm geometry $w +520+200
	}

proc positionWindow5 w {
    wm geometry $w +480+100
	}

proc positionWindow6 w {
    wm geometry $w +600+100
	}


# invoke --
# This procedure is called when the user clicks on a demo description.
# It is responsible for invoking the demonstration.
proc invoke index {
    global tk_library
    global env

    set tags [.t tag names $index]
    set i [lsearch -glob $tags demo-*]
    if {$i < 0} {
	return
    }
    .t configure -cursor watch
    update
    set demo [string range [lindex $tags $i] 5 end]
    uplevel source $env(GALOPPS_GUI_HOME)\/$demo.tcl
    update
    .t configure -cursor xterm
}

proc CommandEntry { name label width args } {
   frame $name
   label $name.label -text $label -width $width -anchor w
   eval {entry $name.entry -width 8 -relief sunken} $args
   pack $name.label -side left
   pack $name.entry -side right -fill x -expand true
   return $name.entry
}

#############################################################################
# ScrolledCanvas
#
# Creates packed canvas w/ scroll bars.
# Usage: set w [scrolled_canvas .c 200 200 [list 0 0 500 500]]
#****************************************************************************
proc scrolled_canvas { c width height region } {
    frame $c -bg white
    canvas $c.canvas -width $width -height $height -bg white \
            -scrollregion $region \
            -xscrollcommand [list $c.xscroll set] \
	    -yscrollcommand [list $c.yscroll set]
	scrollbar $c.xscroll -orient horizontal \
	    -command [list $c.canvas xview]
	scrollbar $c.yscroll -orient vertical \
	    -command [list $c.canvas yview]

	pack $c.xscroll -side bottom -fill x
	pack $c.yscroll -side right -fill y
	pack $c.canvas -side left -fill both -expand true
	pack $c -side top -fill both -expand true
	bind $c.canvas <2> "$c.canvas scan mark %x %y" ;# KPV
	bind $c.canvas <B2-Motion> "$c.canvas scan drag %x %y"
	return $c.canvas
}

#####################################
#write input file for one population
#####################################
proc onepop_write {run_numbers} {
global pap
global numberofruns
global input_fileName

#puts stdout [array get pap]

set f [open $pap(app_name) w 0666]
set input_fileName $pap(app_name)

set msg "/*-----------------------------------------------------------*/"
puts $f $msg
set msg "/*single population file of population             */"
puts $f $msg
set msg "/* $pap(app_name)                                               */"
puts $f $msg
set msg "/*-----------------------------------------------------------*/"
puts $f $msg


# adjust numberofruns
 set numberofruns $run_numbers
# puts stdout $numberofruns
 set pap(app_numberofruns) $run_numbers

# write commend line
 set msg "/* parameters for 1 of $run_numbers */"
 puts $f $msg

# write global parameters
 set msg "numberofruns = $pap(app_numberofruns)"
 puts $f $msg

#write every runs parameter
set run_num [expr $run_numbers + 1]

for {set i 1} {$i < $run_num} {incr i} {
  if {$i!=1} {
   set msg "/* parameters for $i of $run_numbers */"
   puts $f $msg
   }
  set this_time_quiet [lindex $pap(app_quiet) [expr $i - 1]]
  set msg "quiet = $this_time_quiet"
  puts $f $msg
  set this_time_ckptfreq [lindex $pap(app_ckptfreq) [expr $i - 1]]
  set msg "ckptfreq = $this_time_ckptfreq"
  puts $f $msg
  
  set this_time_checkptfileprefix [lindex $pap(app_checkptfileprefix) [expr $i - 1]]
  set msg "checkptfileprefix = $this_time_checkptfileprefix"
  if { $this_time_checkptfileprefix == "-"} {
    set this_time_checkptfileprefix ""
    set msg "checkptfileprefix = $this_time_checkptfileprefix"
    }
  puts $f $msg
  
  set this_time_restartfileprefix [lindex $pap(app_restartfileprefix) [expr $i - 1]]
  set msg "restartfileprefix = $this_time_restartfileprefix"
  if { $this_time_restartfileprefix == "-"} {
    set this_time_restartfileprefix ""
    set msg "restartfileprefix = $this_time_restartfileprefix"
    } 
  puts $f $msg
  
  set this_time_permproblem [lindex $pap(app_permproblem) [expr $i - 1]]
  set msg "permproblem = $this_time_permproblem"
  puts $f $msg
  set this_time_alpha_size [lindex $pap(app_alpha_size) [expr $i - 1]]
  set msg "alpha_size = $this_time_alpha_size"
  puts $f $msg
  set this_time_numfields [lindex $pap(app_numfields) [expr $i - 1]]
  set msg "numfields = $this_time_numfields"
  puts $f $msg
  set this_time_superuniform [lindex $pap(app_superuniform) [expr $i - 1]]
  if { $this_time_superuniform != ""} {
     set msg "superuniform = $this_time_superuniform"
     puts $f $msg
  }
  set this_time_maxgen [lindex $pap(app_maxgen) [expr $i - 1]]
  set msg "maxgen = $this_time_maxgen"
  puts $f $msg
  set this_time_popsize [lindex $pap(app_popsize) [expr $i - 1]]
  set msg "popsize = $this_time_popsize"
  puts $f $msg
  set this_time_printstrings [lindex $pap(app_printstrings) [expr $i - 1]]
  set msg "printstrings = $this_time_printstrings"
  puts $f $msg
  set this_time_pcross [lindex $pap(app_pcross) [expr $i - 1]]
  set msg "pcross = $this_time_pcross"
  puts $f $msg
  set this_time_pmutation [lindex $pap(app_pmutation) [expr $i - 1]]
  set msg "pmutation = $this_time_pmutation"
  puts $f $msg
  set this_time_pinversion [lindex $pap(app_pinversion) [expr $i - 1]]
  set msg "pinversion = $this_time_pinversion"
  puts $f $msg
 
 ################
 ################
  set this_time_autocontrol_selection [lindex $pap(app_autocontrol_selection) [expr $i - 1]]
  set msg "autocontrol_selection = $this_time_autocontrol_selection"
  puts $f $msg
  
  set this_time_beta_s_tilde [lindex $pap(app_beta_s_tilde) [expr $i - 1]]
  set msg "beta_s_tilde = $this_time_beta_s_tilde"
  if {$this_time_autocontrol_selection == "y" } {
    if { $this_time_beta_s_tilde == "-"} {
      set this_time_beta_s_tilde " "
      set msg "beta_s_tilde = $this_time_beta_s_tilde"
    }
    puts $f $msg
  }
  
  set this_time_beta [lindex $pap(app_beta) [expr $i - 1]]
  set msg "beta = $this_time_beta"
  if {$this_time_autocontrol_selection=="n"} {
    if { $this_time_beta == "-"} {
      set this_time_beta " "
      set msg "beta = $this_time_beta"
    }
    puts $f $msg
  }
 ################ 
  set this_time_scaling_window [lindex $pap(app_scaling_window) [expr $i - 1]]
  set msg "scaling_window = $this_time_scaling_window"
  if {$this_time_autocontrol_selection == "n" } {
    puts $f $msg
    }
  
  set this_time_sigma_trunc [lindex $pap(app_sigma_trunc) [expr $i - 1]]
  if { $this_time_sigma_trunc != "-" && $this_time_autocontrol_selection == "n"} {
    set msg "sigma_trunc = $this_time_sigma_trunc"
    puts $f $msg
    }
  
  set this_time_scalemult [lindex $pap(app_scalemult) [expr $i - 1]]
  if { $this_time_scalemult != "-" && $this_time_autocontrol_selection == "n"} {
    set msg "scalemult = $this_time_scalemult"
    puts $f $msg
    }
 ################ 
 ################ 
  set this_time_crowding_factor [lindex $pap(app_crowding_factor) [expr $i - 1]]
  set msg "crowding_factor = $this_time_crowding_factor"
  puts $f $msg
 
  set this_time_incest_reduction [lindex $pap(app_incest_reduction) [expr $i - 1]]
  if { $this_time_incest_reduction != "-"} {
   set msg "incest_reduction = $this_time_incest_reduction"
   puts $f $msg
   }
  
  set this_time_conv_sigma_coeff [lindex $pap(app_conv_sigma_coeff) [expr $i - 1]]
  set msg "conv_sigma_coeff = $this_time_conv_sigma_coeff"
  puts $f $msg
  set this_time_convinterval [lindex $pap(app_convinterval) [expr $i - 1]]
  set msg "convinterval = $this_time_convinterval"
  puts $f $msg
  set this_time_randomseed [lindex $pap(app_randomseed) [expr $i - 1]]
  set msg "randomseed = $this_time_randomseed"
  puts $f $msg
  }

  close $f
}

##############################
# GetValue :get str1 from str2
# Arguments:str1 str2
##############################
proc GetValue {str1 str2 } {
  set s1 [string length $str1]
  set s2 [string length $str2]
  string range $str2 $s1 $s2
}

#####################################
#read input file for one population
#####################################
proc read_one_file {filename} {
 global appname numberofruns checkptfileprefix restartfileprefix
 global permproblem ckptfreq maxgen numfields quiet
 global alpha_size superuniform input_for popsize printstrings
 global pcross pmutation pinversion scaling_window sigma_trunc
 global autocontrol_selection beta_s_tilde beta 
 global scalemult crowding_factor conv_sigma_coeff convinterval
 global incest_reduction randomseed
 global pap

 set pap(app_quiet) {}
 set pap(app_ckptfreq) {}
 set pap(app_checkptfileprefix) {}
 set pap(app_restartfileprefix) {}
 set pap(app_permproblem) {}
 set pap(app_alpha_size) {}
 set pap(app_numfields) {}
 set pap(app_superuniform) {}
 set pap(app_maxgen) {}

 set pap(app_popsize) {}
 set pap(app_printstrings) {}
 set pap(app_pcross) {}
 set pap(app_pmutation) {}
 set pap(app_pinversion) {}
 set pap(app_autocontrol_selection) {}
 set pap(app_beta_s_tilde) {}
 set pap(app_beta) {}
 set pap(app_scaling_window) {}
 set pap(app_sigma_trunc) {}
 set pap(app_scalemult) {}
 set pap(app_crowding_factor) {}
 set pap(app_conv_sigma_coeff) {}
 set pap(app_convinterval) {}
 set pap(app_incest_reduction) {}
 set pap(app_randomseed) {}

 set f [open $filename r 0666]
 set appname $filename
 set pap(app_name) $appname

 # just get data showing on the screen
 while {([gets $f line] >=0)} {
  if [regexp "numberofruns" $line] {
    set numberofruns [GetValue "numberofruns = " $line]
   }
  if [regexp "quiet" $line] {
    set quiet [GetValue "quiet = " $line]
   }
  if [regexp "ckptfreq" $line] {
    set ckptfreq [GetValue "ckptfreq = " $line]
   }
  if [regexp "checkptfileprefix" $line] {
    set checkptfileprefix [GetValue "checkptfileprefix = " $line]
   }
  if [regexp "restartfileprefix" $line] {
    set restartfileprefix [GetValue "restartfileprefix = " $line]
   }
  if [regexp "permproblem" $line] {
    set permproblem [GetValue "permproblem = " $line]
   }
  if [regexp "alpha_size" $line] {
    set alpha_size [GetValue "alpha_size = " $line]
   }
  if [regexp "numfields" $line] {
    set numfields [GetValue "numfields = " $line]
   }
  if [regexp "superuniform" $line] {
    set superuniform [GetValue "superuniform = " $line]
   }
  if [regexp "maxgen" $line] {
    set maxgen [GetValue "maxgen = " $line]
   }
  if [regexp "popsize" $line] {
    set popsize [GetValue "popsize = " $line]
   }
  if [regexp "printstrings" $line] { 
    set printstrings [GetValue "printstrings = " $line]
   }
  if [regexp "pcross" $line] { 
    set pcross [GetValue "pcross = " $line]
   }
  if [regexp "pmutation" $line] { 
     set pmutation [GetValue "pmutation = " $line]
   }
  if [regexp "pinversion" $line] { 
     set pinversion [GetValue "pinversion = " $line]
   }
#############
  if [regexp "autocontrol_selection" $line] {
     set autocontrol_selection [GetValue "autocontrol_selection = " $line]
   }
  if [regexp "beta_s_tilde" $line] {
     set beta_s_tilde [GetValue "beta_s_tilde = " $line]
   }
  if [regexp "beta = " $line] {
     set beta [GetValue "beta = " $line]
   }
#############
  if [regexp "scaling_window" $line] {
     set scaling_window [GetValue "scaling_window = " $line]
   }
  if [regexp "sigma_trunc" $line] {
     set sigma_trunc [GetValue "sigma_trunc = " $line]
   }
  if [regexp "scalemult" $line] {
     set scalemult [GetValue "scalemult = " $line]
   }
  if [regexp "crowding_factor" $line] {
     set crowding_factor [GetValue "crowding_factor = " $line]
   }
  if [regexp "incest_reduction" $line] {
     set incest_reduction [GetValue "incest_reduction = " $line]
   }
  if [regexp "conv_sigma_coeff" $line] {
     set conv_sigma_coeff [GetValue "conv_sigma_coeff = " $line]
   }
  if [regexp "convinterval" $line] {
     set convinterval [GetValue "convinterval = " $line]
   }
  if [regexp "randomseed" $line] {
     set randomseed [GetValue "randomseed = " $line]
   }
  #break
  }
#puts stdout [array get pap]
 close $f

# get data from file for every run
 set f [open $filename r 0666]
 while {([gets $f line] >=0)} {
  if [regexp "quiet" $line] {
   set quiet_cicle [GetValue "quiet = " $line]
   set pap(app_quiet) [concat $pap(app_quiet) $quiet_cicle]
   }
  if [regexp "ckptfreq" $line] {
   set ckptfreq_cicle [GetValue "ckptfreq = " $line]
   set pap(app_ckptfreq) [concat $pap(app_ckptfreq) $ckptfreq_cicle]
   }
  if [regexp "checkptfileprefix" $line] {
   set checkptfileprefix_cicle [GetValue "checkptfileprefix = " $line]
   set pap(app_checkptfileprefix) [concat $pap(app_checkptfileprefix) $checkptfileprefix_cicle]
   }
  if [regexp "restartfileprefix" $line] {
   set restartfileprefix_cicle [GetValue "restartfileprefix = " $line]
   set pap(app_restartfileprefix) [concat $pap(app_restartfileprefix) $restartfileprefix_cicle]
   }
  if [regexp "permproblem" $line] {
   set permproblem_cicle [GetValue "permproblem = " $line]
   set pap(app_permproblem) [concat $pap(app_permproblem) $permproblem_cicle]
   }
  if [regexp "alpha_size" $line] {
   set alpha_size_cicle [GetValue "alpha_size = " $line]
   set pap(app_alpha_size) [concat $pap(app_alpha_size) $alpha_size_cicle]
   }
  if [regexp "numfields" $line] {
   set numfields_cicle [GetValue "numfields = " $line]
   set pap(app_numfields) [concat $pap(app_numfields) $numfields_cicle]
   }
  if [regexp "superuniform" $line] {
   set superuniform_cicle [GetValue "superuniform = " $line]
   set pap(app_superuniform) [concat $pap(app_superuniform) $superuniform_cicle]
   }
  if [regexp "maxgen" $line] {
   set maxgen_cicle [GetValue "maxgen = " $line]
   set pap(app_maxgen) [concat $pap(app_maxgen) $maxgen_cicle]
   }
  if [regexp "popsize" $line] {
    set popsize_cicle [GetValue "popsize = " $line]
    set pap(app_popsize) [concat $pap(app_popsize) $popsize_cicle]
   }
  if [regexp "printstrings" $line] {
    set printstrings_cicle [GetValue "printstrings = " $line]
    set pap(app_printstrings) [concat $pap(app_printstrings) $printstrings_cicle]
   }
  if [regexp "pcross" $line] {
    set pcross_cicle [GetValue "pcross = " $line]
    set pap(app_pcross) [concat $pap(app_pcross) $pcross_cicle]
   }
  if [regexp "pmutation" $line] {
    set pmutation_cicle [GetValue "pmutation = " $line]
    set pap(app_pmutation) [concat $pap(app_pmutation) $pmutation_cicle]
   }
  if [regexp "pinversion" $line] {
    set pinversion_cicle [GetValue "pinversion = " $line]
    set pap(app_pinversion) [concat $pap(app_pinversion) $pinversion_cicle]
   }

   ####################
  if [regexp "autocontrol_selection" $line] {
    set autocontrol_selection_cicle [GetValue "autocontrol_selection = " $line]
    set pap(app_autocontrol_selection) [concat $pap(app_autocontrol_selection) $autocontrol_selection_cicle]
   }
  if [regexp "beta_s_tilde" $line] {
    set beta_s_tilde_cicle [GetValue "beta_s_tilde = " $line]
    set pap(app_beta_s_tilde) [concat $pap(app_beta_s_tilde) $beta_s_tilde_cicle]
   }
  if [regexp "beta = " $line] {
    set beta_cicle [GetValue "beta = " $line]
    set pap(app_beta) [concat $pap(app_beta) $beta_cicle]
   }
   ####################

  if [regexp "scaling_window" $line] {
    set scaling_window_cicle [GetValue "scaling_window = " $line]
    set pap(app_scaling_window) [concat $pap(app_scaling_window) $scaling_window_cicle]
   }
  if [regexp "sigma_trunc" $line] {
    set sigma_trunc_cicle [GetValue "sigma_trunc = " $line]
    set pap(app_sigma_trunc) [concat $pap(app_sigma_trunc) $sigma_trunc_cicle]
   }
  if [regexp "scalemult" $line] {
    set scalemult_cicle [GetValue "scalemult = " $line]
    set pap(app_scalemult) [concat $pap(app_scalemult) $scalemult_cicle]
   }
  if [regexp "crowding_factor" $line] {
    set crowding_factor_cicle [GetValue "crowding_factor = " $line]
    set pap(app_crowding_factor) [concat $pap(app_crowding_factor) $crowding_factor_cicle]
   }
  if [regexp "incest_reduction" $line] {
    set incest_reduction_cicle [GetValue "incest_reduction = " $line]
    set pap(app_incest_reduction) [concat $pap(app_incest_reduction) $incest_reduction_cicle]
   }
  if [regexp "conv_sigma_coeff" $line] {
    set conv_sigma_coeff_cicle [GetValue "conv_sigma_coeff = " $line]
    set pap(app_conv_sigma_coeff) [concat $pap(app_conv_sigma_coeff) $conv_sigma_coeff_cicle]
   }
  if [regexp "convinterval" $line] {
    set convinterval_cicle [GetValue "convinterval = " $line]
    set pap(app_convinterval) [concat $pap(app_convinterval) $convinterval_cicle]
   }
  if [regexp "randomseed" $line] {
    set randomseed_cicle [GetValue "randomseed = " $line]
    set pap(app_randomseed) [concat $pap(app_randomseed) $randomseed_cicle]
   }
 }
 close $f

#$$$$$$$$$$$$$$$$$$$
# give "-" to every empty list
set length [llength $pap(app_popsize)]

 if {$pap(app_checkptfileprefix) == ""} {
   set checkptfileprefix "-"
   for {set i 0} {$i < 1} {incr i} {
     set pap(app_checkptfileprefix) [concat $pap(app_checkptfileprefix) "-"]
   }
 }

 if {$pap(app_restartfileprefix) == ""} {
   set restartfileprefix "-"
   for {set i 0} {$i < 1} {incr i} {
     set pap(app_restartfileprefix) [concat $pap(app_restartfileprefix) "-"]
   }
 }

 if {$pap(app_beta_s_tilde) == ""} {
   set beta_s_tilde "-"
   for {set i 0} {$i <$length} {incr i} {
     set pap(app_beta_s_tilde) [concat $pap(app_beta_s_tilde) "-"]
   }
 }

 if {$pap(app_beta) == ""} {
   set beta "-"
   for {set i 0} {$i <$length} {incr i} {
     set pap(app_beta) [concat $pap(app_beta) "-"]
   }
 }

 if {$pap(app_scaling_window) == ""} {
    set scaling_window "-"
    for {set i 0} {$i <$length} {incr i} {
       set pap(app_scaling_window) [concat $pap(app_scaling_window) "-"]
    }
 }

 if {$pap(app_sigma_trunc) == ""} {
    set sigma_trunc "-"
    for {set i 0} {$i <$length} {incr i} {
       set pap(app_sigma_trunc) [concat $pap(app_sigma_trunc) "-"]
    }
 }

 if {$pap(app_scalemult) == ""} {
    set scalemult "-"
    for {set i 0} {$i <$length} {incr i} {
       set pap(app_scalemult) [concat $pap(app_scalemult) "-"]
    }
 }

 if {$pap(app_incest_reduction) == ""} {
    set incest_reduction "-"
    for {set i 0} {$i <$length} {incr i} {
      set pap(app_incest_reduction) [concat $pap(app_incest_reduction) "-"]
    }
 }

 set input_for [llength $pap(app_popsize)]
 set old_input $input_for
# puts stdout [array get pap]
}

#####################################
#write input file for many population
#####################################
proc manypops_write {ncycles_num} {
global papm
#puts stdout $ncycles_num

set f [open $papm(app_name) w 0666]
set input_fileName $papm(app_name)

set msg "/*-----------------------------------------------------------*/"
puts $f $msg
set msg "/*Many populations file of population             */"
puts $f $msg
set msg "/* $papm(app_name)                                               */"
puts $f $msg
set msg "/*-----------------------------------------------------------*/"
puts $f $msg

# adjust npops
set npops $ncycles_num
#puts stdout $npops
set papm(app_npops) $ncycles_num

# write global parameters
set msg "npops = $papm(app_npops)"
puts $f $msg
set msg "startpopnum = $papm(app_startpopnum)"
puts $f $msg
set msg "finishpopnum = $papm(app_finishpopnum)"
#set papm(app_startpopnum) $startpopnum
puts $f $msg
set msg "ncycles = $papm(app_ncycles)"
puts $f $msg
set msg "quiet = $papm(app_quiet)"
puts $f $msg

set msg "checkptfileprefix = $papm(app_checkptfileprefix)"
if {$papm(app_checkptfileprefix) == "-"} {
   set msg "checkptfileprefix = "
   }
puts $f $msg

set msg "restartfileprefix = $papm(app_restartfileprefix)"
if {$papm(app_restartfileprefix) == "-"} {
   set msg "restartfileprefix = "
   }
puts $f $msg

set msg "masterfileprefix = $papm(app_masterfileprefix)"
puts $f $msg
set msg "permproblem = $papm(app_permproblem)"
puts $f $msg
set msg "all_subpops_use_same_parameters = $papm(app_all_subpops_use_same_parameters)"
puts $f $msg

for {set i 0} {$i < $ncycles_num} {incr i} {
  set msg "/* parameters for Subpopulation $i */"
  puts $f $msg
 
  set this_time_alpha_size [lindex $papm(app_alpha_size) $i ]
  set msg "alpha_size = $this_time_alpha_size"
  puts $f $msg

  set this_time_numfields [lindex $papm(app_numfields) $i] 
  set msg "numfields = $this_time_numfields"
  puts $f $msg

  set this_time_superuniform [lindex $papm(app_superuniform) $i] 
  if { $papm(app_superuniform) != ""} {
    set msg "superuniform = $this_time_superuniform"
    puts $f $msg
   }
 
  set this_time_genspercycle [lindex $papm(app_genspercycle) $i]
  set msg "genspercycle = $this_time_genspercycle"
  puts $f $msg
  
  set this_time_popsize [lindex $papm(app_popsize) $i]
  set msg "popsize = $this_time_popsize"
  puts $f $msg
 
  set this_time_printstrings [lindex $papm(app_printstrings) $i]
  set msg "printstrings = $this_time_printstrings"
  puts $f $msg
  set this_time_pcross [lindex $papm(app_pcross) $i]
  set msg "pcross = $this_time_pcross"
  puts $f $msg
  set this_time_pmutation [lindex $papm(app_pmutation) $i]
  set msg "pmutation = $this_time_pmutation"
  puts $f $msg
  set this_time_pinversion [lindex $papm(app_pinversion) $i]
  set msg "pinversion = $this_time_pinversion"
  puts $f $msg

############################
############################
  set this_time_autocontrol_selection [lindex $papm(app_autocontrol_selection) $i]
  set msg "autocontrol_selection = $this_time_autocontrol_selection"
  puts $f $msg

  set this_time_beta_s_tilde [lindex $papm(app_beta_s_tilde) [expr $i - 1]]
  set msg "beta_s_tilde = $this_time_beta_s_tilde"
  if {$this_time_autocontrol_selection == "y" } {
    if { $this_time_beta_s_tilde == "-"} {
      set this_time_beta_s_tilde " "
      set msg "beta_s_tilde = $this_time_beta_s_tilde"
      }
    puts $f $msg
  }

  set this_time_beta [lindex $papm(app_beta) [expr $i - 1]]
  set msg "beta = $this_time_beta"
  if {$this_time_autocontrol_selection=="n"} {
    if { $this_time_beta == "-"} {
      set this_time_beta " "
      set msg "beta = $this_time_beta"
     }
   puts $f $msg
  }
############################
  set this_time_scaling_window [lindex $papm(app_scaling_window) $i]
  set msg "scaling_window = $this_time_scaling_window"
  if {$this_time_autocontrol_selection == "n" } {
    puts $f $msg
   }

  set this_time_sigma_trunc [lindex $papm(app_sigma_trunc) $i]
  set msg "sigma_trunc = $this_time_sigma_trunc"
  if { $this_time_sigma_trunc != "-" && $this_time_autocontrol_selection == "n"} {
    puts $f $msg
  }
  
  set this_time_scalemult [lindex $papm(app_scalemult) $i]
  set msg "scalemult = $this_time_scalemult"
  if { $this_time_scalemult != "-" && $this_time_autocontrol_selection == "n"} {
    puts $f $msg
  }
############################
############################
  set this_time_crowding_factor [lindex $papm(app_crowding_factor) $i]
  set msg "crowding_factor = $this_time_crowding_factor"
  puts $f $msg

  set this_time_incest_reduction [lindex $papm(app_incest_reduction) $i]
  if { $this_time_incest_reduction != "-"} {
    set msg "incest_reduction = $this_time_incest_reduction"
    puts $f $msg
  }

  set this_time_conv_sigma_coeff [lindex $papm(app_conv_sigma_coeff) $i]
  set msg "conv_sigma_coeff = $this_time_conv_sigma_coeff"
  puts $f $msg
  set this_time_convinterval [lindex $papm(app_convinterval) $i]
  set msg "convinterval = $this_time_convinterval"
  puts $f $msg

  set this_time_field_size [lindex $papm(app_field_size) $i]
  if { $this_time_field_size != "-"} {
    set msg "field_size = $this_time_field_size"
    puts $f $msg
  }

  if {$i == 0} {
    set msg "randomseed = $papm(app_randomseed)"
    puts $f $msg
  }
 }
  
 close $f
}

#####################################
#read input file for many population
#####################################
proc read_many_file {filename} {
global current_path

global appnamem npops checkptfileprefix restartfileprefix quiet  
global startpopnum finishpopnum ncycles masterfileprefix 
global permproblem all_subpops_use_same_parameters randomseed input_form 
global alpha_size numfields genspercycle superuniform popsize printstrings
global pcross pmutation pinversion scaling_window sigma_trunc
global autocontrol_selection beta_s_tilde beta
global scalemult crowding_factor conv_sigma_coeff convinterval
global incest_reduction field_size 
global papm

set papm(app_npops) {}
set papm(app_startpopnum) {}
set papm(app_finishpopnum) {}
set papm(app_ncycles) {}
set papm(app_quiet) {}
set papm(app_checkptfileprefix) {}
set papm(app_restartfileprefix) {}
set papm(app_masterfileprefix) {}
set papm(app_permproblem) {}
set papm(app_all_subpops_use_same_parameters) {}
set papm(app_randomseed) {}

set papm(app_alpha_size) {}
set papm(app_numfields) {}
set papm(app_superuniform) {}
set papm(app_genspercycle) {}
set papm(app_popsize) {}
set papm(app_printstrings) {}
set papm(app_pcross) {}
set papm(app_pmutation) {}
set papm(app_pinversion) {}
set papm(app_autocontrol_selection) {}
set papm(app_beta_s_tilde) {}
set papm(app_beta) {}
set papm(app_scaling_window) {}
set papm(app_sigma_trunc) {}
set papm(app_scalemult) {}
set papm(app_crowding_factor) {}
set papm(app_incest_reduction) {}
set papm(app_conv_sigma_coeff) {}
set papm(app_convinterval) {}
set papm(app_field_size) {}

set f [open $filename r 0666]
set appnamem $filename
set papm(app_name) $appnamem

#for subpopulation 0 and global paramaters
 while {([gets $f line] >=0)} {
   if [regexp "npops" $line] {
    set npops [GetValue "npops = " $line]
    set papm(app_npops) [concat $papm(app_npops) $npops]
   }
   if [regexp "startpopnum" $line] {
     set startpopnum [GetValue "startpopnum = " $line]
     set papm(app_startpopnum) [concat $papm(app_startpopnum) $startpopnum]
    }
   if [regexp "finishpopnum" $line] {
     set finishpopnum [GetValue "finishpopnum = " $line]
     set papm(app_finishpopnum) [concat $papm(app_finishpopnum) $finishpopnum]
    }
   if [regexp "ncycles" $line] {
     set ncycles [GetValue "ncycles = " $line]
     set papm(app_ncycles) [concat $papm(app_ncycles) $ncycles]
    }
   if [regexp "quiet" $line] {
    set quiet [GetValue "quiet = " $line]
    set papm(app_quiet) [concat $papm(app_quiet) $quiet]
   }
   if [regexp "checkptfileprefix" $line] {
    set checkptfileprefix [GetValue "checkptfileprefix = " $line]
    set papm(app_checkptfileprefix) [concat $papm(app_checkptfileprefix) $checkptfileprefix]
   }
   if [regexp "restartfileprefix" $line] {
    set restartfileprefix [GetValue "restartfileprefix = " $line]
    set papm(app_restartfileprefix) [concat $papm(app_restartfileprefix) $restartfileprefix]
   }
   if [regexp "masterfileprefix" $line] {
    set masterfileprefix [GetValue "masterfileprefix = " $line]
   # 33set ls /
   # set masterfileprefix $current_path$ls$masterfileprefix 
    set papm(app_masterfileprefix) [concat $papm(app_masterfileprefix) $masterfileprefix]
   }
   if [regexp "permproblem" $line] {
    set permproblem [GetValue "permproblem = " $line]
    set papm(app_permproblem) [concat $papm(app_permproblem) $permproblem]
   }
   if [regexp "all_subpops_use_same_parameters" $line] {
    set all_subpops_use_same_parameters [GetValue "all_subpops_use_same_parameters = " $line]
    set papm(app_all_subpops_use_same_parameters) [concat $papm(app_all_subpops_use_same_parameters) $all_subpops_use_same_parameters]
   }
   if [regexp "randomseed" $line] {
    set randomseed [GetValue "randomseed = " $line]
    set papm(app_randomseed) [concat $papm(app_randomseed) $randomseed]
   }
  }
 close $f

  set f [open $filename r 0666]
  while {([gets $f line] >=0)} {
  if [regexp "alpha_size" $line] {
    set alpha_size_cicle [GetValue "alpha_size = " $line]
    set alpha_size $alpha_size_cicle
    set papm(app_alpha_size) [concat $papm(app_alpha_size) $alpha_size_cicle]
    }
  if [regexp "numfields" $line] {
    set numfields_cicle [GetValue "numfields = " $line]
    set numfields $numfields_cicle
    set papm(app_numfields) [concat $papm(app_numfields) $numfields_cicle]
   }
  if [regexp "superuniform" $line] {
    set superuniform_cicle [GetValue "superuniform = " $line]
    set superuniform $superuniform_cicle
    set papm(app_superuniform) [concat $papm(app_superuniform) $superuniform_cicle]
   }
  if [regexp "genspercycle" $line] {
    set genspercycle_cicle [GetValue "genspercycle = " $line]
    set genspercycle $genspercycle_cicle
    set papm(app_genspercycle) [concat $papm(app_genspercycle) $genspercycle_cicle]
   }
  if [regexp "popsize" $line] {
    set popsize_cicle [GetValue "popsize = " $line]
    set popsize $popsize_cicle
    set papm(app_popsize) [concat $papm(app_popsize) $popsize_cicle]
   }
  if [regexp "printstrings" $line] {
    set printstrings_cicle [GetValue "printstrings = " $line]
    set printstrings $printstrings_cicle
    set papm(app_printstrings) [concat $papm(app_printstrings) $printstrings_cicle]
   }
  if [regexp "pcross" $line] {
    set pcross_cicle [GetValue "pcross = " $line]
    set pcross $pcross_cicle
    set papm(app_pcross) [concat $papm(app_pcross) $pcross_cicle]
   }
  if [regexp "pmutation" $line] {
    set pmutation_cicle [GetValue "pmutation = " $line]
    set pmutation $pmutation_cicle
    set papm(app_pmutation) [concat $papm(app_pmutation) $pmutation_cicle]
   }
  if [regexp "pinversion" $line] {
    set pinversion_cicle [GetValue "pinversion = " $line]
    set pinversion $pinversion_cicle
    set papm(app_pinversion) [concat $papm(app_pinversion) $pinversion_cicle]
   }

#############
  if [regexp "autocontrol_selection" $line] {
    set autocontrol_selection_cicle [GetValue "autocontrol_selection = " $line]
    set autocontrol_selection $autocontrol_selection_cicle
    set papm(app_autocontrol_selection) [concat $papm(app_autocontrol_selection) $autocontrol_selection_cicle]
   }
  if [regexp "beta_s_tilde" $line] {
    set beta_s_tilde_cicle [GetValue "beta_s_tilde = " $line]
    set beta_s_tilde $beta_s_tilde_cicle
    set papm(app_beta_s_tilde) [concat $papm(app_beta_s_tilde) $beta_s_tilde_cicle]
   }
  if [regexp "beta = " $line] {
    set beta_cicle [GetValue "beta = " $line]
    set beta $beta_cicle
    set papm(app_beta) [concat $papm(app_beta) $beta_cicle]
   }
#############
  if [regexp "scaling_window" $line] {
    set scaling_window_cicle [GetValue "scaling_window = " $line]
    set scaling_window $scaling_window_cicle
    set papm(app_scaling_window) [concat $papm(app_scaling_window) $scaling_window_cicle]
   }
  if [regexp "sigma_trunc" $line] {
    set sigma_trunc_cicle [GetValue "sigma_trunc = " $line]
    set sigma_trunc $sigma_trunc_cicle
    set papm(app_sigma_trunc) [concat $papm(app_sigma_trunc) $sigma_trunc_cicle]
   }
  if [regexp "scalemult" $line] {
    set scalemult_cicle [GetValue "scalemult = " $line]
    set scalemult $scalemult_cicle
    set papm(app_scalemult) [concat $papm(app_scalemult) $scalemult_cicle]
   }
  if [regexp "crowding_factor" $line] {
    set crowding_factor_cicle [GetValue "crowding_factor = " $line]
    set crowding_factor $crowding_factor_cicle
    set papm(app_crowding_factor) [concat $papm(app_crowding_factor) $crowding_factor_cicle]
   }
  if [regexp "incest_reduction" $line] {
    set incest_reduction_cicle [GetValue "incest_reduction = " $line]
    set incest_reduction $incest_reduction_cicle
    set papm(app_incest_reduction) [concat $papm(app_incest_reduction) $incest_reduction_cicle]
   }
  if [regexp "conv_sigma_coeff" $line] {
    set conv_sigma_coeff_cicle [GetValue "conv_sigma_coeff = " $line]
    set conv_sigma_coeff $conv_sigma_coeff_cicle
    set papm(app_conv_sigma_coeff) [concat $papm(app_conv_sigma_coeff) $conv_sigma_coeff_cicle]
   }
  if [regexp "convinterval" $line] {
    set convinterval_cicle [GetValue "convinterval = " $line]
    set convinterval $convinterval_cicle
    set papm(app_convinterval) [concat $papm(app_convinterval) $convinterval_cicle]
   }
  if [regexp "field_size" $line] {
    set field_size_cicle [GetValue "field_size = " $line]
    set field_size $field_size_cicle
    set papm(app_field_size) [concat $papm(app_field_size) $field_size_cicle]
    }
   }
 close $f
#$$$$$$$$$$
#$$$$$$$$$$$$$$$$$$$
# give "-" to every empty list
set length [llength $papm(app_popsize)]

 if {$papm(app_checkptfileprefix) == ""} {
    set checkptfileprefix "-"
    for {set i 0} {$i < 1} {incr i} {
      set papm(app_checkptfileprefix) [concat $papm(app_checkptfileprefix) "-"]
       }
 }

 if {$papm(app_restartfileprefix) == ""} {
    set restartfileprefix "-"
    for {set i 0} {$i < 1} {incr i} {
       set papm(app_restartfileprefix) [concat $papm(app_restartfileprefix) "-"]
       }
 }

 if {$papm(app_beta_s_tilde) == ""} {
    set beta_s_tilde "-"
    for {set i 0} {$i <$length} {incr i} {
       set papm(app_beta_s_tilde) [concat $papm(app_beta_s_tilde) "-"]
      }
 }

 if {$papm(app_beta) == ""} {
    set beta "-"
    for {set i 0} {$i <$length} {incr i} {
      set papm(app_beta) [concat $papm(app_beta) "-"]
      }
 }

 if {$papm(app_scaling_window) == ""} {
    set scaling_window "-"
    for {set i 0} {$i <$length} {incr i} {
       set papm(app_scaling_window) [concat $papm(app_scaling_window) "-"]
    }
 }

 if {$papm(app_sigma_trunc) == ""} {
   set sigma_trunc "-"
   for {set i 0} {$i <$length} {incr i} {
     set papm(app_sigma_trunc) [concat $papm(app_sigma_trunc) "-"]
   }
 }

 if {$papm(app_scalemult) == ""} {
   set scalemult "-"
   for {set i 0} {$i <$length} {incr i} {
     set papm(app_scalemult) [concat $papm(app_scalemult) "-"]
   }
 }

 if {$papm(app_incest_reduction) == ""} {
   set incest_reduction "-"
   for {set i 0} {$i <$length} {incr i} {
     set papm(app_incest_reduction) [concat $papm(app_incest_reduction) "-"]
    }
 }

 if {$papm(app_field_size) == ""} {
    set field_size "-"
    for {set i 0} {$i <$length} {incr i} {
      set papm(app_field_size) [concat $papm(app_field_size) "-"]
    }
 }

 set k [llength $papm(app_popsize)]
 set input_form [expr $k-1]
 set old_inputm $input_form

#puts stdout [array get papm]
}

proc GetValue1 {str1 str2 line} {
  set length_s1 [string length $str1]
  set position_s1 [string first $str1 $line]
  set position_s2 [string first $str2 $line]
  set position1 [expr $length_s1 + $position_s1]
  set position2 [expr $position_s2 - 1]
  string range $line $position1 $position2
}

#####################################
#read master file 
#####################################
proc read_master_file {}  {
 global current_path

 global node_X
 global node_Y
 global dd_num
 global dd

 global mca_list_value
 global mir_list_value
 global random_list_value
 global best_list_value
 
 global papm

 global env

 set best_list_value {}
 set random_list_value {}
 set mir_list_value {}
 set mca_list_value {}
 
 set mst ".mst"
 set ls /
#puts stdout $current_path$ls$papm(app_masterfileprefix)$mst 
 set f [open $current_path$ls$papm(app_masterfileprefix)$mst r 0666]
 
 set best_random_mca_mir {}
 while {([gets $f line] >=0)} {
  if [regexp "/*X" $line] {
   set node_X1 [GetValue1 "/*X:" "*/" $line]
   }
  if [regexp "/*Y" $line] {
   set node_Y1 [GetValue1 "/*Y:" "*/" $line]
   }
  if [regexp "/*sorted" $line] {
   set all_relation [GetValue1 "/*sorted:" "*/" $line]
   }
  if [regexp "neighbor" $line] {
   set best_random_mca_mir [GetValue "  neighbor = " $line]
  # puts stdout $best_random_mca_mir
   set best_random [lindex $best_random_mca_mir 1]
   if {$best_random <0} {
     set best_list_value [concat $best_list_value 1]
     set devide [expr abs($best_random)] 
     set random_list_value [concat $random_list_value [expr $devide - 1]]
    }
   if {$best_random > 0} {
     set best_list_value [concat $best_list_value 0]
     set random_list_value [concat $random_list_value $best_random]
    }
   set mca_list_value [concat $mca_list_value [lindex $best_random_mca_mir 2]]
   set mir_list_value [concat $mir_list_value [lindex $best_random_mca_mir 3]]
   }
  }
 close $f
 
puts "environments:"
puts $env(PATH)
puts $env(GALOPPS_GUI_HOME)
 source $env(GALOPPS_GUI_HOME)\/migration.tcl
 mkRelation $all_relation

 # puts stdout $best_list_value
 # puts stdout $random_list_value
 # puts stdout $mir_list_value
 # puts stdout $mca_list_value
 
 set length [llength $node_X1]
 for {set i 0} {$i<$length} {incr i} {
   set x_cood [lindex $node_X1 $i]
   set y_cood [lindex $node_Y1 $i]
   mkNode $x_cood $y_cood
  }

 set length1 [llength $all_relation]
 for {set i 0} {$i<$length1} {incr i 2} {
  set first_value [lindex $all_relation $i]
  set first_node [lindex $dd $first_value]

  set j [expr $i + 1]
  set second_value [lindex $all_relation $j]
  set second_node [lindex $dd $second_value]
  mkEdge $first_node $second_node
  }
}
#puts stdout [array get pap]
#puts stdout [array names pap]

