# relation.tcl

set w .migration
catch {destroy $w}
toplevel $w
wm title $w "Migration of subpopulations"
wm iconname $w "migration"
positionWindow4 $w

global current_path

frame $w.buttons
pack  $w.buttons -side bottom -expand y -fill x -pady 2m
button $w.buttons.dismiss -text Dismiss -command "destroy $w"
button $w.buttons.set -text "Write .mst file" -command "write_masterfile"

#
# NEW addition of Help button on 7/15/96 by Owen Mathews and Erik Goodman
#
 
button $w.buttons.help -text "Help" -command "helpDialog migrants.help"
 
pack $w.buttons.help $w.buttons.dismiss $w.buttons.set -side left -expand 1
 
#
# END new addition
#

#pack $w.buttons.dismiss $w.buttons.set -side left -expand 1

set c $w.c
set w [scrolled_canvas $c 400 600 [list 0 0 600 60000]]
pack $w

 

#######################################
# write master file                   #
# argument:no                         #
#######################################
proc write_masterfile { } {
 global current_path

 global papm
 global dd
 global npops

 global sorted_list
 global mca_list_value
 global mir_list_value
 global random_list_value
 global best_list_value

 global node_X
 global node_Y

 set true_dode_num [llength $dd]
 #puts stdout $true_dode_num
 set papm(app_npops) $true_dode_num
 set npops $true_dode_num

 set relation 0
 set length [llength $sorted_list]
 set num_relation 0

 set mst ".mst"
 set ls /

# puts stdout $current_path$ls$papm(app_masterfileprefix)$mst
 set f [open $current_path$ls$papm(app_masterfileprefix)$mst w 0666]

 set msg "/*----------------------------------------------------------------------------*/"
 puts $f $msg
 set msg "/*X:$node_X*/"
 puts $f $msg
 set msg "/*Y:$node_Y*/"
 puts $f $msg
 set msg "/*sorted:$sorted_list*/"
 puts $f $msg
 set msg "/*----------------------------------------------------------------------------*/"
 puts $f $msg

 set msg "subcnt = $papm(app_npops)"
 puts $f $msg
 for {set i 0} {$i < $papm(app_npops)} {incr i 1} {
  set neighbour_value 0
  set k 0
  #set signal 100
  set sig 888
  for {set j 0} {$j < $length} {incr j 2} {
    set count [lindex $sorted_list $j] 
    if {$i == $count} {
      set sig 999
      incr neighbour_value 1

      set count_next [expr $j + 1]
      set neighbour [lindex $sorted_list $count_next]
    
      set best [lindex $best_list_value $relation]
      set random [lindex $random_list_value $relation]
      set mir [lindex $mir_list_value $relation]
      set mca [lindex $mca_list_value $relation]
      set relation [expr $relation + 1]
      set best_random_total [expr $best + $random]
      set best_random $best_random_total
      if {$best != 0} {
	set best_random [expr 0-$best_random_total]
	}
      set msg$k "  neighbor = $neighbour $best_random $mca $mir"
      incr k 1
   } 
 } 
  
  if {$sig == 888} {
       set msg_msg "subpop = $i 0"
       puts $f $msg_msg
       set sig 888
       }

 if { $neighbour_value != 0} {
  set msg "subpop = $i $neighbour_value"
  puts $f $msg
  }
 for {set l 0} {$l < $k} {incr l 1} {
  set msg [set msg$l] 
  puts $f $msg
  }
 } 
 close $f
}

#######################################
# initial the four list               #
#######################################
proc mkInitial {} {
 global sorted_list
 global mca_list_value
 global mir_list_value
 global random_list_value
 global best_list_value
 global mca_list
 global mir_list
 global random_list
 global best_list

 set best_list {}
 set best_list_value {}
 set random_list {}
 set random_list_value {}
 set mir_list {}
 set mir_list_value {}
 set mca_list {}
 set mca_list_value {}

 set length [llength $sorted_list]
 set time [expr $length/2]

 for {set i 0} {$i <$time} {incr i} {
  set best_list_value [concat $best_list_value 0]
  set random_list_value [concat $random_list_value 1]
  set mir_list_value [concat $mir_list_value 3]
  set mca_list_value [concat $mca_list_value 4]
 }
}

#######################################
#draw every pair of relation on screen#
#######################################
proc mkRelation { like_sorted_list } {
 global font
 global sorted_list
 global mca_list_value
 global mir_list_value
 global random_list_value
 global best_list_value
 
 global mca_list
 global mir_list
 global random_list
 global best_list
 set mca_list {}
 set mir_list {}
 set random_list {}
 set best_list {}

 global best_x_y
 global random_x_y
 global mir_x_y
 global mca_x_y
 
 set x1 30
 set x2 90
 set y1 80

 set sorted_list $like_sorted_list
 set length [llength $sorted_list]
 set time [expr $length/2]
 set font -Adobe-Helvetica-Medium-R-Normal--*-180-*

for {set i 0} {$i < $length} {incr i 2} {
# draw the getting subpopution
set x $x1
set y [expr $y1+$i*110]
.migration.c.canvas create oval [expr $x-12] [expr $y-12] \
	    [expr $x+12] [expr $y+12] -outline black -fill white
set num_sub_get [lindex $sorted_list $i]
.migration.c.canvas create text $x $y -text "$num_sub_get" -anchor center

# draw the giving subpopution
set x $x2
set next [expr $i + 1]
set num_sub_give [lindex $sorted_list $next] 
.migration.c.canvas create oval [expr $x-12] [expr $y-12] \
	    [expr $x+12] [expr $y+12] -outline black -fill white
.migration.c.canvas create text $x $y -text "$num_sub_give" -anchor center

# draw the line <-- between getting and giving subpopution
set line_point_x1 [expr $x1 + 12]
set line_point_y1 $y
set line_point_x2 [expr $x2 - 12]
set line_point_y2 $y
.migration.c.canvas create line $line_point_x1 $line_point_y1 $line_point_x2 \
   $line_point_y2 -arrow first -width 2

# draw "best" text and the adjusting dot value
set best_x [expr $x + 40]
set best_y $y
.migration.c.canvas create text $best_x $best_y -text "best" -font $font -anchor center

set best_note_x [expr $best_x + 30]
set best_note_y $y
set best_index [.migration.c.canvas create oval [expr $best_note_x-6] [expr $best_note_y-6] \
	       [expr $best_note_x+6] [expr $best_note_y+6] -outline black -fill black \
               -tags best ]
set best_list [concat $best_list $best_index]

set best_value_x [expr $best_note_x + 20]
set best_value_y $y
lappend best_x_y($best_index) $best_value_x
lappend best_x_y($best_index) $best_value_y
#puts stdout [array get best_x_y]
set kk [expr $i/2]
set this_time_best [lindex $best_list_value $kk]
#puts stdout $this_time_best
.migration.c.canvas create text $best_value_x $best_value_y -text "($this_time_best)" -font $font -anchor center

# draw "random" text and the adjusting dot and value
set random_x [expr $x + 150]
set random_y $y
.migration.c.canvas create text $random_x $random_y -text "random" -font $font -anchor center

set random_note_x [expr $random_x + 40]
set random_note_y $y
set random_index [.migration.c.canvas create oval [expr $random_note_x-6] [expr $random_note_y-6] \
        	     [expr $random_note_x+6] [expr $random_note_y+6] -outline black -fill black \
        	    -tags random ]
set random_list [concat $random_list $random_index]

set random_value_x [expr $random_note_x + 20]
set random_value_y $y
lappend random_x_y($random_index) $random_value_x
lappend random_x_y($random_index) $random_value_y
set kk [expr $i/2]
set this_time_random [lindex $random_list_value $kk]
.migration.c.canvas create text $random_value_x $random_value_y -text "($this_time_random)" -font $font -anchor center


# draw "migration_incest_reduction" text and the adjusting dot and value
set mir_x [expr $random_note_x + 18]
set mir_y [expr $y-10]

set mir_line_x1 $mir_x
set mir_line_y1 $mir_y
set mir_line_x2 $mir_line_x1
set mir_line_y2 [expr $mir_line_y1 - 20]
.migration.c.canvas create line $mir_line_x1 $mir_line_y1 $mir_line_x2 \
   $mir_line_y2 -arrow first -width 2

set mir_value_x $mir_x
set mir_value_y [expr $mir_y  - 30]
set kk [expr $i/2]
set this_time_mir [lindex $mir_list_value $kk]
.migration.c.canvas create text $mir_value_x $mir_value_y -text "($this_time_mir)" -font $font -anchor center

set mir_note_x $mir_x
set mir_note_y [expr $mir_y -50]
set mir_index [.migration.c.canvas create oval [expr $mir_note_x-6] [expr $mir_note_y-6] \
              [expr $mir_note_x+6] [expr $mir_note_y+6] -outline black -fill black \
	      -tags mir]
set mir_list [concat $mir_list $mir_index]

set mir_text_x 175
set mir_text_y [expr $mir_y-50]
lappend mir_x_y($mir_index) $mir_value_x
lappend mir_x_y($mir_index) $mir_value_y
.migration.c.canvas create text $mir_text_x $mir_text_y -text "migration_incest_reduction" -font $font -anchor center

# draw "migration_crowding_amt" text and the adjusting dot and value
set mca_x $mir_x
set mca_y [expr $mir_y+40]

set mca_line_x1 $mca_x
set mca_line_y1 $mca_y
set mca_line_x2 $mca_line_x1
set mca_line_y2 [expr $mca_line_y1 - 20]
.migration.c.canvas create line $mca_line_x1 $mca_line_y1 $mca_line_x2 \
   $mca_line_y2 -arrow last -width 2

set mca_value_x $mca_x
set mca_value_y [expr $mca_y + 10]
set kk [expr $i/2]
set this_time_mca [lindex $mca_list_value $kk]
.migration.c.canvas create text $mca_value_x $mca_value_y -text "($this_time_mca)" -font $font -anchor center
 
set mca_note_x $mir_x
set mca_note_y [expr $mca_y + 30]
set mca_index [.migration.c.canvas create oval [expr $mca_note_x-6] [expr $mca_note_y-6] \
	      [expr $mca_note_x+6] [expr $mca_note_y+6] -outline black -fill black \
              -tags mca]
set mca_list [concat $mca_list $mca_index]

set mca_text_x 185
set mca_text_y [expr $mca_y + 30]
lappend mca_x_y($mca_index) $mca_value_x
lappend mca_x_y($mca_index) $mca_value_y
.migration.c.canvas create text $mca_text_x $mca_text_y -text "migration_crowding_amt" -font $font -anchor center
}
}

############
# bind work#
############
.migration.c.canvas bind best <Any-Enter> {
 .migration.c.canvas itemconfigure current -fill SeaGreen1
}

.migration.c.canvas bind best <Any-Leave> {
 .migration.c.canvas itemconfigure current -fill black
}

.migration.c.canvas bind best <Button-1> {
 .migration.c.canvas itemconfigure current -fill red
}

.migration.c.canvas bind best <ButtonRelease-1> {
 .migration.c.canvas itemconfigure current -fill SeaGreen1
 set best_tag [.migration.c.canvas find withtag current]
 set index [lsearch $best_list $best_tag]
 set best_value_old [lindex $best_list_value $index]
 if {$best_value_old == 0 } {
   set best_value_new [expr $best_value_old + 1]
   set best_list_value [lreplace $best_list_value $index $index $best_value_new]
   set x [lindex $best_x_y($best_tag) 0]
   set y [lindex $best_x_y($best_tag) 1]
   .migration.c.canvas create text $x $y -text "($best_value_old)" -fill white -font $font -anchor center
   .migration.c.canvas create text $x $y -text "($best_value_new)" -fill black -font $font -anchor center
 }
}

.migration.c.canvas bind best <Button-2> {
 .migration.c.canvas itemconfigure current -fill blue
}

.migration.c.canvas bind best <ButtonRelease-2> {
 .migration.c.canvas itemconfigure current -fill SeaGreen1
 set best_tag [.migration.c.canvas find withtag current]
 set index [lsearch $best_list $best_tag]
 set best_value_old [lindex $best_list_value $index]
 if {$best_value_old == 1 } {
   set best_value_new [expr $best_value_old - 1]
   set best_list_value [lreplace $best_list_value $index $index $best_value_new]
   set x [lindex $best_x_y($best_tag) 0]
   set y [lindex $best_x_y($best_tag) 1]
   .migration.c.canvas create text $x $y -text "($best_value_old)" -fill white -font $font -anchor center
   .migration.c.canvas create text $x $y -text "($best_value_new)" -fill black -font $font -anchor center
  }
}

.migration.c.canvas bind random <Any-Enter> {
 .migration.c.canvas itemconfigure current -fill SeaGreen1
}

.migration.c.canvas bind random <Any-Leave> {
 .migration.c.canvas itemconfigure current -fill black
}

.migration.c.canvas bind random <Button-1> {
 .migration.c.canvas itemconfigure current -fill red
}

.migration.c.canvas bind random <ButtonRelease-1> {
 .migration.c.canvas itemconfigure current -fill SeaGreen1
 set random_tag [.migration.c.canvas find withtag current]
 set index [lsearch $random_list $random_tag]
 set random_value_old [lindex $random_list_value $index]
 if {$random_value_old < 8 } {
  set random_value_new [expr $random_value_old + 1]
  set random_list_value [lreplace $random_list_value $index $index $random_value_new]
  set x [lindex $random_x_y($random_tag) 0]
  set y [lindex $random_x_y($random_tag) 1]
  .migration.c.canvas create text $x $y -text "($random_value_old)" -fill white -font $font -anchor center
  .migration.c.canvas create text $x $y -text "($random_value_new)" -fill black -font $font -anchor center
 }
}

.migration.c.canvas bind random <Button-2> {
 .migration.c.canvas itemconfigure current -fill blue
}

.migration.c.canvas bind random <ButtonRelease-2> {
 .migration.c.canvas itemconfigure current -fill SeaGreen1
 set random_tag [.migration.c.canvas find withtag current]

 set index [lsearch $random_list $random_tag]
 set random_value_old [lindex $random_list_value $index]
 if {$random_value_old >= 1 } {
  set random_value_new [expr $random_value_old - 1]
  set random_list_value [lreplace $random_list_value $index $index $random_value_new]
  set x [lindex $random_x_y($random_tag) 0]
  set y [lindex $random_x_y($random_tag) 1]
  .migration.c.canvas create text $x $y -text "($random_value_old)" -fill white -font $font -anchor center
  .migration.c.canvas create text $x $y -text "($random_value_new)" -fill black -font $font -anchor center
 }
}

.migration.c.canvas bind mir <Any-Enter> {
 .migration.c.canvas itemconfigure current -fill SeaGreen1
}

.migration.c.canvas bind mir <Any-Leave> {
 .migration.c.canvas itemconfigure current -fill black
}

.migration.c.canvas bind mir <Button-1> {
 .migration.c.canvas itemconfigure current -fill red
}

.migration.c.canvas bind mir <ButtonRelease-1> {
 .migration.c.canvas itemconfigure current -fill SeaGreen1
 set mir_tag [.migration.c.canvas find withtag current]
 set index [lsearch $mir_list $mir_tag]
 set mir_value_old [lindex $mir_list_value $index]
 if {$mir_value_old < 10 } {
   set mir_value_new [expr $mir_value_old + 1]
   set mir_list_value [lreplace $mir_list_value $index $index $mir_value_new]
   set x [lindex $mir_x_y($mir_tag) 0]
   set y [lindex $mir_x_y($mir_tag) 1]
   .migration.c.canvas create text $x $y -text "($mir_value_old)" -fill white -font $font -anchor center
   .migration.c.canvas create text $x $y -text "($mir_value_new)" -fill black -font $font -anchor center
   }
}

.migration.c.canvas bind mir <Button-2> {
 .migration.c.canvas itemconfigure current -fill blue
}

.migration.c.canvas bind mir <ButtonRelease-2> {
 .migration.c.canvas itemconfigure current -fill SeaGreen1
 set mir_tag [.migration.c.canvas find withtag current]
 set index [lsearch $mir_list $mir_tag]
 set mir_value_old [lindex $mir_list_value $index]
 if {$mir_value_old >= 1 } {
   set mir_value_new [expr $mir_value_old - 1]
   set mir_list_value [lreplace $mir_list_value $index $index $mir_value_new]
   set x [lindex $mir_x_y($mir_tag) 0]
   set y [lindex $mir_x_y($mir_tag) 1]
   .migration.c.canvas create text $x $y -text "($mir_value_old)" -fill white -font $font -anchor center
   .migration.c.canvas create text $x $y -text "($mir_value_new)" -fill black -font $font -anchor center
   }
}

.migration.c.canvas bind mca <Any-Enter> {
 .migration.c.canvas itemconfigure current -fill SeaGreen1
}

.migration.c.canvas bind mca <Any-Leave> {
 .migration.c.canvas itemconfigure current -fill black
}

.migration.c.canvas bind mca <Button-1> {
 .migration.c.canvas itemconfigure current -fill red
}

.migration.c.canvas bind mca <ButtonRelease-1> {
 .migration.c.canvas itemconfigure current -fill SeaGreen1
 set mca_tag [.migration.c.canvas find withtag current]
 set index [lsearch $mca_list $mca_tag]
 set mca_value_old [lindex $mca_list_value $index]
 if {$mca_value_old < 10 } {
    set mca_value_new [expr $mca_value_old + 1]
    set mca_list_value [lreplace $mca_list_value $index $index $mca_value_new]
    set x [lindex $mca_x_y($mca_tag) 0]
    set y [lindex $mca_x_y($mca_tag) 1]
    .migration.c.canvas create text $x $y -text "($mca_value_old)" -fill white -font $font -anchor center
    .migration.c.canvas create text $x $y -text "($mca_value_new)" -fill black -font $font -anchor center
  }
}

.migration.c.canvas bind mca <Button-2> {
 .migration.c.canvas itemconfigure current -fill blue
}

.migration.c.canvas bind mca <ButtonRelease-2> {
 .migration.c.canvas itemconfigure current -fill SeaGreen1
 set mca_tag [.migration.c.canvas find withtag current]
 set index [lsearch $mca_list $mca_tag]
 set mca_value_old [lindex $mca_list_value $index]
 if {$mca_value_old >= 1 } {
    set mca_value_new [expr $mca_value_old - 1]
    set mca_list_value [lreplace $mca_list_value $index $index $mca_value_new]
    set x [lindex $mca_x_y($mca_tag) 0]
    set y [lindex $mca_x_y($mca_tag) 1]
    .migration.c.canvas create text $x $y -text "($mca_value_old)" -fill white -font $font -anchor center
    .migration.c.canvas create text $x $y -text "($mca_value_new)" -fill black -font $font -anchor center
    }
}

