set w .display
catch {destroy $w}
toplevel $w
wm title $w "Display"
wm iconname $w "display"
positionWindow5 $w

set c $w.c
canvas $c -width 650 -height 450 -bg white
pack $w.c

global max_gen
global min_gen
global max_fit
global min_fit
set max_gen 100
set min_gen 0
set max_fit 1.0
set min_fit 0.0

set old_max_gen 100
set old_min_gen 0
set old_max_fit 1.0
set old_min_fit 0.0

global new_max_gen
global new_min_gen
global new_max_fit
global new_min_fit
set new_max_gen 100
set new_min_gen 0
set new_max_fit 1.0
set new_min_fit 0.0

global time_up
global time_down
global time_left
global time_right

set time_up 0
set time_down 0
set time_left 0
set time_right 0

global adj_view_ini
global output_fileName
global application_name
global fileName1

frame $w.1 
frame $w.1.1
frame $w.1.2
frame $w.1.3
frame $w.2
frame $w.3
frame $w.4
pack $w.1 $w.2 $w.4 $w.3 -side top -expand 1 

# draw fitness(max. and min.)
frame $w.1.1.fit
frame $w.1.1.fit.max
label $w.1.1.fit.max.text -text "Fitness(max.)      "
entry $w.1.1.fit.max.entry -width 6 -relief sunken -bd 2 -textvariable fitmax
pack $w.1.1.fit.max.text $w.1.1.fit.max.entry -side left
set fitmax 1.0

frame $w.1.1.fit.min
label $w.1.1.fit.min.text -text "Fitness(min.)     "
entry $w.1.1.fit.min.entry -width 6 -relief sunken -bd 2 -textvariable fitmin
pack $w.1.1.fit.min.text $w.1.1.fit.min.entry -side left
set fitmin 0.0
pack $w.1.1.fit.max $w.1.1.fit.min -side left

# draw generation(max. and min.)
frame $w.1.1.gen
frame $w.1.1.gen.max
label $w.1.1.gen.max.text -text "Generation(max.)"
entry $w.1.1.gen.max.entry -width 6 -relief sunken -bd 2 -textvariable genmax
pack $w.1.1.gen.max.text $w.1.1.gen.max.entry -side left
set genmax 100

frame $w.1.1.gen.min
label $w.1.1.gen.min.text -text "Generation(min.)"
entry $w.1.1.gen.min.entry -width 6 -relief sunken -bd 2 -textvariable genmin
pack $w.1.1.gen.min.text $w.1.1.gen.min.entry -side left
set genmin 0
pack $w.1.1.gen.max $w.1.1.gen.min -side left

# draw number of runs
frame $w.1.1.runs
label $w.1.1.runs.text -text "Number of Runs             "
entry $w.1.1.runs.entry -width 6 -relief sunken -bd 2 -textvariable numruns
pack $w.1.1.runs.text $w.1.1.runs.entry -side left
set numruns 1

# draw number of subpopulation
frame $w.1.1.subs
label $w.1.1.subs.text -text "Number of Subpopulation"
entry $w.1.1.subs.entry -width 6 -relief sunken -bd 2 -textvariable numsubs
pack $w.1.1.subs.text $w.1.1.subs.entry -side left
set numsubs 0
pack  $w.1.1.fit $w.1.1.gen $w.1.1.runs $w.1.1.subs -side top -expand y -fill x -pady 2m

frame $w.1.2.check
frame $w.1.2.check.b1
checkbutton $w.1.2.check.b1.text -text "Max" -variable max_ok -relief flat
label $w.1.2.check.b1.color -text "---" -fg red
pack $w.1.2.check.b1.text $w.1.2.check.b1.color -side left

frame $w.1.2.check.b2
checkbutton $w.1.2.check.b2.text -text "Min" -variable min_ok -relief flat
label $w.1.2.check.b2.color -text "---" -fg blue
pack $w.1.2.check.b2.text $w.1.2.check.b2.color -side left

frame $w.1.2.check.b3
checkbutton $w.1.2.check.b3.text -text "Mean" -variable mean_ok -relief flat
label $w.1.2.check.b3.color -text "---" -fg green
pack $w.1.2.check.b3.text $w.1.2.check.b3.color -side left

frame $w.1.3.raw_scaled
pack $w.1.3.raw_scaled
radiobutton $w.1.3.raw -text "Raw Fitness   " -variable raw_scaled \
		-value raw
radiobutton $w.1.3.scaled -text "Scaled Fitness" -variable raw_scaled \
		-value scaled
pack $w.1.3.raw $w.1.3.scaled -side top
set raw_scaled raw

pack $w.1.2.check
pack $w.1.1 $w.1.2 -side left -expand 1 -fill x
pack $w.1.1 $w.1.2.check -side left -expand 1 -fill x
pack $w.1.2.check.b1 $w.1.2.check.b2 $w.1.2.check.b3 -side top -anchor w

frame $w.2.application_name
label $w.2.application_name.text -text "Application"
entry $w.2.application_name.entry -width 12 -relief sunken -bd 2 -textvariable application_name
pack $w.2.application_name.text $w.2.application_name.entry -side left
 set plot_append "plot"
 set application_name $output_fileName$plot_append
pack $w.2.application_name

frame $w.3.buttons
pack $w.3.buttons 
button $w.3.buttons.dismiss -text Dismiss -command "destroy $w"
button $w.3.buttons.plot -text "Plot" -command {
 if {$number_pop == "one"} {
  plot_one .display.c $application_name $numruns $raw_scaled $max_gen \
	   $min_gen $max_fit $min_fit $max_ok $min_ok $mean_ok
  }
  if {$number_pop == "many"} {
  plot_many .display.c $application_name $numsubs $raw_scaled \
	   $max_gen $min_gen $max_fit $min_fit $max_ok $min_ok $mean_ok
  }
}
pack $w.3.buttons.dismiss $w.3.buttons.plot -side left -expand 1 -fill x

frame $w.4.population
pack $w.4.population
radiobutton $w.4.population.many -text "Many Populations" -variable number_pop \
		-value many
radiobutton $w.4.population.one -text "One Population   " -variable number_pop \
		-value one
pack $w.4.population.one $w.4.population.many -side left -fill x
set number_pop one

pack $w.1.1 $w.1.2 $w.1.3 -side left -expand 1

#draw line to divide the canvas into two parts
.display.c create line 0 400 650 400 -width 2p
.display.c create line 0 450 650 450 -width 2p

proc initial_screen {} {
#draw coordinates x and y
 set y1_append [expr 40 - 15]
 set y2_append [expr 340 +15]
 .display.c create line 100 $y1_append 100 $y2_append -arrow first -width 2
 set x1_append [expr 100-15]
 set x2_append [expr 600+15]
 .display.c create line $x1_append 340 $x2_append 340 -arrow last -width 2

 .display.c create text 8c 11c -text "Generation  Number" -anchor w
 .display.c create text 2.5c 0.5c -text "Fitness" -anchor w
 .display.c create text 7.0c 0.4c -text "Fitness  Evolution" -anchor w
 .display.c create text 0.6c 12c -text "Scale Adjustment" -anchor w

###############################
#draw scales of x and y axles #
###############################
#draw scales of x (longer)
 for {set i 0} {$i < 10} {incr i} {
  set x1 100
  set y1 [expr $i*30+40]
  set x2 [expr $x1-8]
  set y2 $y1
  .display.c create line $x1 $y1 $x2 $y2
 }

#draw scales of x (shorter)
 for {set i 0} {$i < 100} {incr i} {
  set x1 100
  set y1 [expr $i*3+40]
  set x2 [expr $x1-4]
  set y2 $y1
 .display.c create line $x1 $y1 $x2 $y2
 }

#draw scales of y (longer)
 for {set i 0} {$i < 11} {incr i} {
  set x1 [expr 100+50*$i]
  set y1 340
  set x2 $x1
  set y2 [expr $y1+8]
  .display.c create line $x1 $y1 $x2 $y2
 }

#draw scales of y (shorter)
 for {set i 0} {$i < 100} {incr i} {
  set x1 [expr 100+5*$i]
  set y1 340
  set x2 $x1
  set y2 [expr $y1+4]
  .display.c create line $x1 $y1 $x2 $y2
 }
}
initial_screen 

###########################################
#draw the numbers of the scales on X axle #
###########################################
proc mkNum_axle_x {x_max x_min color} {
 for {set i 1} {$i <12} {incr i} {
   set step [expr ($x_max-$x_min)/10.0] 
   
   set j [expr $i-1] 
   set number [expr $x_min + $step*$j]
   set x [expr $j*50+100]
   set y [expr 340 + 15]

   .display.c create text $x $y -text ${number} -fill ${color} -anchor n
  }
}

###########################################
#draw the numbers of the scales on Y axle #
###########################################
proc mkNum_axle_y {y_max y_min color} {
 for {set i 1} {$i <12} {incr i} {
    set step [expr ($y_max-$y_min)/10.0]
    
    set j [expr $i-1] 
    set number [expr $y_min + $step*$j]
    set x [expr 100-12]
    set y [expr 340-$j*30]

    .display.c create text $x $y -text ${number} -fill ${color} -anchor e
    }
}

#############################################
# set initial generation and fitness value  #
# for plot on X axle and Y axle             #
#############################################
mkNum_axle_x $new_max_gen $new_min_gen black
mkNum_axle_y $new_max_fit $new_min_fit black

############################
# draw adjustment rectangle#
############################
set x 4.0
set y 11.2

set y1 [expr $y+0.5]
set y2 [expr $y1+0.6]

#draw first
set x1 [expr $x+0.5]
set x2 [expr $x1+0.6]
.display.c create rectangle ${x1}c ${y1}c ${x2}c ${y2}c -width 1p -outline blue -fill white  -tags adj_y_up

#draw second
set x1 [expr $x+0.5+1*1.0]
set x2 [expr $x1+0.6]
.display.c create rectangle ${x1}c ${y1}c ${x2}c ${y2}c -width 1p -outline blue -fill white  -tags adj_y_down

#draw third
set x1 [expr $x+0.5+2*1.0]
set x2 [expr $x1+0.6]
.display.c create rectangle ${x1}c ${y1}c ${x2}c ${y2}c -width 1p -outline blue -fill white  -tags adj_x_left

#draw fourth
set x1 [expr $x+0.5+3*1.0]
set x2 [expr $x1+0.6]
.display.c create rectangle ${x1}c ${y1}c ${x2}c ${y2}c -width 1p -outline blue -fill white  -tags adj_x_right

#draw fifth
set x1 [expr $x+0.5+4*1.0]
set x2 [expr $x1+0.6]
.display.c create rectangle ${x1}c ${y1}c ${x2}c ${y2}c -width 1p -outline blue -fill white  -tags adj_view_ini

#set initial coordinate
set x 4.0
set y 11.2

#draw X_axis up
set x1 [expr 0.5+$x+0.3]
set y1 [expr $y+0.5]
set x2 $x1
set y2 [expr $y+1.0]
.display.c create line ${x1}c ${y1}c ${x2}c ${y2}c -width 10p -arrow first -fill blue

#draw X_axis down
set x1 [expr 0.5+$x+0.30+1.0]
set y1 [expr $y+0.60+0.05]
set x2 $x1
set y2 [expr $y+1.0+0.1]
.display.c create line ${x1}c ${y1}c ${x2}c ${y2}c -width 10p -arrow last -fill blue

#draw Y_axis up
set x1 [expr 0.5+$x+2.0]
set y1 [expr $y+0.50+0.3]
set x2 [expr 0.5+$x1]
set y2 $y1
.display.c create line ${x1}c ${y1}c ${x2}c ${y2}c -width 10p -arrow first -fill blue

#draw Y_axis down
set x1 [expr 0.5+$x+0.1+3.0+0.05]
set y1 [expr $y+0.50+0.3]
set x2 [expr 0.4+$x1+0.05]
set y2 $y1
.display.c create line ${x1}c ${y1}c ${x2}c ${y2}c -width 10p -arrow last -fill blue

#Draw view in window
set x1 [expr 0.5+$x+4.3]
set y1 [expr $y+0.50]
set x2 $x1
set y2 [expr $y+0.5+0.25]
.display.c create line ${x1}c ${y1}c ${x2}c ${y2}c -width 5p -arrow last -fill blue
set x1 [expr 0.5+$x+4.3]
set y1 [expr $y+0.50+0.6]
set x2 $x1
set y2 [expr $y+0.5-0.25+0.6]
.display.c create line ${x1}c ${y1}c ${x2}c ${y2}c -width 5p -arrow last -fill blue
set x1 [expr 0.5+$x+4.0]
set y1 [expr $y+0.50+0.3]
set x2 [expr 0.5+$x+4.0+0.25]
set y2 $y1
.display.c create line ${x1}c ${y1}c ${x2}c ${y2}c -width 5p -arrow last -fill blue	
set x1 [expr 0.5+$x+4.0+0.6]
set y1 [expr $y+0.50+0.3]
set x2 [expr 0.5+$x+4.0-0.25+0.6]
set y2 $y1
.display.c create line ${x1}c ${y1}c ${x2}c ${y2}c -width 5p -arrow last -fill blue

############################
# to deal every bind event #
############################
#for change the color when pointer entry the rectangles
.display.c bind adj_y_up <Any-Enter> {
    .display.c itemconfig current -fill black
}
.display.c bind adj_y_up <Any-Leave> {
    .display.c itemconfig current -fill white
}

.display.c bind adj_y_down <Any-Enter> {
    .display.c itemconfigure current -fill black
}
.display.c bind adj_y_down <Any-Leave> {
    .display.c itemconfigure current -fill white
}

.display.c bind adj_x_left <Any-Enter> {
    .display.c itemconfigure current -fill black
}
.display.c bind adj_x_left <Any-Leave> {
    .display.c itemconfigure current -fill white
}

.display.c bind adj_x_right <Any-Enter> {
   .display.c itemconfigure current -fill black
}
.display.c bind adj_x_right <Any-Leave> {
   .display.c itemconfigure current -fill white
}

.display.c bind adj_view_ini <Any-Enter> {
   .display.c itemconfigure current -fill black
}
.display.c bind adj_view_ini <Any-Leave> {
   .display.c itemconfigure current -fill white
} 

# when click button 1 in one of five rectangles
.display.c bind adj_x_right <Button-1> {
  if {$time_right < 10 } {
  mkNum_axle_x $old_max_gen $old_min_gen white
  set new_max_gen [expr $old_max_gen*2.0]
  set new_min_gen [expr $old_min_gen*2.0]
  mkNum_axle_x $new_max_gen $new_min_gen black
  set old_max_gen $new_max_gen
  set old_min_gen $new_min_gen
  set time_right [expr $time_right + 1] 
  set time_left [expr $time_left - 1]
  }
}

.display.c bind adj_x_left <ButtonRelease-1> {
  if {$time_left < 10 } {
    mkNum_axle_x $old_max_gen $old_min_gen white
    set new_max_gen [expr $old_max_gen/2.0]
    set new_min_gen [expr $old_min_gen/2.0]
    mkNum_axle_x $new_max_gen $new_min_gen black
    set old_max_gen $new_max_gen
    set old_min_gen $new_min_gen
    set time_right [expr $time_right - 1] 
    set time_left [expr $time_left + 1]
   }
}

.display.c bind adj_y_up <ButtonRelease-1> {
  if {$time_up < 10 } {
    mkNum_axle_y $old_max_fit $old_min_fit white
    set new_max_fit [expr $old_max_fit*2.0]
    set new_min_fit [expr $old_min_fit*2.0]
    mkNum_axle_y $new_max_fit $new_min_fit black
    set old_min_fit $new_min_fit
    set old_max_fit $new_max_fit
    set time_down [expr $time_down - 1]
    set time_up [expr $time_up + 1]
  }
}

.display.c bind adj_y_down <ButtonRelease-1> {
  if {$time_down < 10 } {
    mkNum_axle_y $old_max_fit $old_min_fit white
    set new_max_fit [expr $old_max_fit/2.0]
    set new_min_fit [expr $old_min_fit/2.0]
    mkNum_axle_y $new_max_fit $new_min_fit black
    set old_min_fit $new_min_fit
    set old_max_fit $new_max_fit
    set time_down [expr $time_down + 1]
    set time_up [expr $time_up - 1]
   }
}

.display.c bind adj_view_ini <ButtonRelease-1> {
 mkNum_axle_x $old_max_gen $old_min_gen white
 mkNum_axle_y $old_max_fit $old_min_fit white
 set new_max_gen $max_gen
 set new_min_gen $min_gen
 set new_max_fit $max_fit
 set new_min_fit $min_fit
 mkNum_axle_x $new_max_gen $new_min_gen black
 mkNum_axle_y $new_max_fit $new_min_fit black
 set old_min_fit $new_min_fit
 set old_max_fit $new_max_fit
 set old_max_gen $new_max_gen
 set old_min_gen $new_min_gen
 set time_up 0
 set time_down 0
 set time_right 0
 set time_left 0
}

bind $w.1.1.fit.max.entry <KeyRelease> {
 set max_fit $fitmax
}

bind $w.1.1.fit.min.entry <KeyRelease> {
 set min_fit $fitmin
}

bind $w.1.1.gen.max.entry <KeyRelease> {
 set max_gen $genmax
}

bind $w.1.1.gen.min.entry <KeyRelease> {
 set min_gen $genmin
}

bind $w.1.1.runs.entry <KeyRelease> {
 set this_time_plot_runs $numruns
}

bind $w.1.1.subs.entry <KeyRelease> { 
 set this_time_plot_subs $numsubs
}

bind $w.2.application_name.entry <KeyRelease> { 
 set this_time_plot_application $application_name
}

################################################
#plot on screen
################################################
proc plot_on_screen {fit_value gen_value color} {
 global new_min_gen
 global new_max_gen
 global new_min_fit
 global new_max_fit
 
 global min_first_x
 global min_first_y
 global min_second_x
 global min_second_y
 global max_first_x
 global max_first_y
 global max_second_x
 global max_second_y
 global avg_first_x
 global avg_first_y
 global avg_second_x
 global avg_second_y
 
 set delta 2

 set y [expr 340-300*($fit_value-$new_min_fit)/($new_max_fit-$new_min_fit)]
 set x [expr 100+500*($gen_value-$new_min_gen)/($new_max_gen-$new_min_gen)]
 if { $color == "blue" } {
   set min_second_x $x
   set min_second_y $y
  }
 if { $color == "red" } {
   set max_second_x $x
   set max_second_y $y
  }
 if { $color == "green" } {
   set avg_second_x $x
   set avg_second_y $y
  }

 set first_point [expr $new_min_gen +1] 
 if {$gen_value == $first_point} {
  if { $color == "blue" } {
    set min_first_x $min_second_x
    set min_first_y $min_second_y
    }
  if { $color == "red" } {
    set max_first_x $max_second_x
    set max_first_y $max_second_y
    }
  if { $color == "green" } {
    set avg_first_x $avg_second_x
    set avg_first_y $avg_second_y
    }
  }

 set x1 [expr $x -$delta]
 set x2 [expr $x +$delta]
 set y1 [expr $y -$delta]
 set y2 [expr $y +$delta]

 .display.c create oval $x1 $y1 $x2 $y2 -fill $color -outline $color
 update idletasks
 if { $color == "blue" } {
  .display.c create line $min_first_x $min_first_y $min_second_x $min_second_y -fill $color
  update idletasks
  }
 if { $color == "red" } {
  .display.c create line $max_first_x $max_first_y $max_second_x $max_second_y -fill $color
  update idletasks
  }
 if { $color == "green" } {
  .display.c create line $avg_first_x $avg_first_y $avg_second_x $avg_second_y -fill $color
  update idletasks
  }

 if { $color == "blue" } {
   set min_first_x $min_second_x
   set min_first_y $min_second_y
   }
 if { $color == "red" } {
   set max_first_x $max_second_x
   set max_first_y $max_second_y
   }
 if { $color == "green" } {
   set avg_first_x $avg_second_x
   set avg_first_y $avg_second_y
   }
}

################################################
#reach at the read position every time
#argument:num_lines(from which line to be read)
################################################
proc read_one_line {begin_position num_line} {
 global signal_read
 global ff
 global readed_line_value
    
 set signal [gets $ff line]
 set readed_line_value $line
}

##############################################################################
proc plot_one {window fileName run_number raw_scaled max_gen min_gen max_fit \
   min_fit plot_max plot_min plot_avg} { 
##############################################################################
 global new_min_gen
 global new_max_gen
 global new_min_fit
 global new_max_fit

 global tcl_precision 
 set tcl_precision 4
 global pap
 global signal_read
 global ff
 global readed_line_value
 
 global application_name

 global fileName1

 set plot_append "plot"
 set recorder 0

 read_one_file $fileName1
 
#clear the screen and re_initial
 .display.c create rectangle 1 1 649 395 -fill white -outline white
 update idletasks
 initial_screen 
 update idletasks
 mkNum_axle_x $new_max_gen $new_min_gen black
 update idletasks
 mkNum_axle_y $new_max_fit $new_min_fit black
 update idletasks

#calculate the first line of reading(begin position)
 set begin_position [expr 6*$new_min_gen]
 set k [expr $run_number -1]
 for {set i 0} {$i < $k} {incr i} {
  set this_maxgen [lindex $pap(app_maxgen) $i]
  set this_run_lines [expr 6*$this_maxgen]
  set begin_position [expr $begin_position +$this_run_lines]
 }
 #puts stdout $begin_position

#calculate how many lines shoud be read
 set i [expr $run_number -1]
 set this_maxgen [lindex $pap(app_maxgen) $i]
 if {$new_min_gen >= $this_maxgen} {
  return 111
  }
 set plot_generation [expr $new_max_gen - $new_min_gen]
 if {$new_max_gen > $this_maxgen} {
  set plot_generation [expr $this_maxgen - $new_min_gen]
  } 
 set lines [expr 6*$plot_generation]
 #puts stdout $lines

#open the plot file and read one line then plot on the screen
 while {[catch {open $application_name r} ff] == 1} {
  after 10
 }

 for {set i 0} {$i < $begin_position} {incr i} {
  gets $ff line
  set readed_line_value $line
 }
	   
 while {$recorder < $lines} {
   read_one_line $begin_position $recorder
   set mod_line [expr fmod($recorder,6)]
   set gen_value [expr $recorder/6 + 1 + $new_min_gen]
   if { ($mod_line == 0.0) && ($raw_scaled == "raw") && ($plot_min == 1)} {
    plot_on_screen $readed_line_value $gen_value blue
    } elseif { ($mod_line == 1.0) && ($raw_scaled == "raw") && ($plot_max == 1)} {
    plot_on_screen $readed_line_value $gen_value red
    } elseif { ($mod_line == 2.0) && ($raw_scaled == "raw") && ($plot_avg == 1)} {
    plot_on_screen $readed_line_value $gen_value green
    } elseif { ($mod_line == 3.0) && ($raw_scaled == "scaled") && ($plot_min == 1)} {
    plot_on_screen $readed_line_value $gen_value blue
    } elseif { ($mod_line == 4.0) && ($raw_scaled == "scaled") && ($plot_max == 1)} {
    plot_on_screen $readed_line_value $gen_value red
    } elseif { ($mod_line == 5.0) && ($raw_scaled == "scaled") && ($plot_avg == 1)} {
    plot_on_screen $readed_line_value $gen_value green
    }
   incr recorder
   }
 close $ff
}

################################################
#reach at the read position every time
#argument:num_lines(from which line to be read)
################################################
proc read_one_line_many {begin_position all_lines_for_one_cycle one_cycle_lines num_line} {
 global signal_read
 global ff
 global readed_line_value

 set value1 [expr fmod($num_line,$one_cycle_lines)]

 set leap_line [expr $all_lines_for_one_cycle - $one_cycle_lines] 

 if {($value1 == 0.0) && ($num_line>=$one_cycle_lines)} { 
    for {set i 0} {$i <= $leap_line} {incr i} {
     set signal [gets $ff line]
     set readed_line_value $line
    } 
 }

 if {($value1 != 0.0) || ($num_line<$one_cycle_lines)} { 
    set signal [gets $ff line]
    set readed_line_value $line
  }
 
}

################################################################################
proc plot_many {window fileName subs_number raw_scaled max_gen min_gen max_fit \
      min_fit plot_max plot_min plot_avg} {
################################################################################
  global new_min_gen
  global new_max_gen
  global new_min_fit
  global new_max_fit
  
  global tcl_precision
  set tcl_precision 4
  global papm
  global signal_read
  global ff
  global readed_line_value

  global application_name

  global fileName1 
 
  set recorder 0

read_many_file $fileName1

#clear the screen and re_initial
  .display.c create rectangle 1 1 649 395 -fill white -outline white
  update idletasks
  initial_screen
  update idletasks
  mkNum_axle_x $new_max_gen $new_min_gen black
  update idletasks
  mkNum_axle_y $new_max_fit $new_min_fit black
  update idletasks

#calculate the first line of reading(begin position)
  #puts stdout $subs_number

  set begin_position 0
  for {set i 0} {$i < $subs_number} {incr i} {
   set this_gencycle [lindex $papm(app_genspercycle) $i]
   set this_gencycle_lines [expr 6*$this_gencycle]
   set begin_position [expr $begin_position +$this_gencycle_lines]
   }
  #puts stdout $begin_position

#calculate how many lines shoud be read
  set this_gencycle [lindex $papm(app_genspercycle) $subs_number]
  set one_cycle_lines [expr 6*$this_gencycle]
  set lines [expr 6*$this_gencycle*$papm(app_ncycles)]

#calculate how many lines for one genspercycle
  set all_lines_for_one_cycle 0
  for {set i 0} {$i < $papm(app_npops)} {incr i} {
   set this_gencycle [lindex $papm(app_genspercycle) $i]
   set this_gencycle_lines [expr 6*$this_gencycle]
   set all_lines_for_one_cycle [expr $all_lines_for_one_cycle + $this_gencycle_lines]
   }

#open the plot file and read one line then plot on the screen
 while {[catch {open $application_name r} ff] == 1} {
   after 10
 }

 for {set i 0} {$i < $begin_position} {incr i} {
    gets $ff line
    set readed_line_value $line
  }

 while {$recorder < $lines} {
   read_one_line_many $begin_position $all_lines_for_one_cycle $one_cycle_lines $recorder
     set mod_line [expr fmod($recorder,6)]
     set gen_value [expr $recorder/6 + 1 + $new_min_gen]
     if { ($mod_line == 0.0) && ($raw_scaled == "raw") && ($plot_min == 1)} {
      plot_on_screen $readed_line_value $gen_value blue
      } elseif { ($mod_line == 1.0) && ($raw_scaled == "raw") && ($plot_max == 1)} {
      plot_on_screen $readed_line_value $gen_value red
      } elseif { ($mod_line == 2.0) && ($raw_scaled == "raw") && ($plot_avg == 1)} {
      plot_on_screen $readed_line_value $gen_value green
      } elseif { ($mod_line == 3.0) && ($raw_scaled == "scaled") && ($plot_min == 1)} {
      plot_on_screen $readed_line_value $gen_value blue
      } elseif { ($mod_line == 4.0) && ($raw_scaled == "scaled") && ($plot_max == 1)} {
      plot_on_screen $readed_line_value $gen_value red
      } elseif { ($mod_line == 5.0) && ($raw_scaled == "scaled") && ($plot_avg == 1)} {
      plot_on_screen $readed_line_value $gen_value green
      }
     incr recorder
 } 
 close $ff
}

