/*
Library for GGA
Last modified 07/28/95
*/



#include "gga.h"

  


  




void determine_percent_optimal(chrominfo)
struct group_chrom chrominfo;
{
  int group_sizes[MAX_NUM_OF_OBJECTS];
  int count1;
  int number_of_optimal;
  double percent_optimal;

  number_of_optimal=0;
  determine_group_sizes(chrominfo,group_sizes);
  chrominfo.number_of_groups=determine_num_of_groups(chrominfo);
  for(count1=0; count1<chrominfo.number_of_groups; count1++)
    {
      if(group_sizes[count1]==bin_size)
        {
          number_of_optimal++;
        }
    }
  percent_optimal=number_of_optimal*1.0/chrominfo.number_of_groups;
  fprintf(outfp,"\n percent opt = %f",percent_optimal);
}




 

void print_chr(chrominfo)
struct group_chrom chrominfo;
{
  int count1;
  int determin_num_of_groups();

  fprintf(outfp,"\nObject:\n");
  for (count1=0; count1<number_of_objects; count1++)
    {
      fprintf(outfp," %d ",chrominfo.object[count1]);
    }
  fprintf(outfp,"\nGroup:\n");
  for (count1=0; count1<number_of_objects; count1++)
    {
      fprintf(outfp," %d ",chrominfo.group[count1]);
    }
  fprintf(outfp," \n Number of Groups = %d ",determine_num_of_groups(chrominfo));
  fprintf(outfp," \n x1 = %d ",chrominfo.x1);
  fprintf(outfp," \n x2 = %d ",chrominfo.x2);

}



   


void determine_group_sizes(chrominfo, group_sizes)
struct group_chrom chrominfo;
int group_sizes[];
{
  int count1;

  for (count1=0; count1<number_of_objects; count1++)
    {
      group_sizes[count1]=0;
    }
  for (count1=0; count1<number_of_objects; count1++)
    {
      group_sizes[chrominfo.object[count1]] = group_sizes[chrominfo.object[count1]]
 + object_information[count1];
    }
}





/*
Packs the bits, uses less memory and more CPU.
*/
void make_binary2(chrominfo, chrom)
  struct group_chrom chrominfo;
  unsigned *chrom;
{                                                    

  int array_position;
  int bitnumber=1;
  int count1, count2;
  unsigned mask=1;
  unsigned leftmask;




  for(count1=0; count1<chromsize; count1++)
    {
      chrom[count1]=0;
    }
    
  leftmask=mask<<(UINTSIZE-1); 


  array_position=0;  
  bitnumber=1;
  for(count1=0; count1<number_of_objects; count1++)
    {
       for(count2=1; count2<=fieldlength; count2++)
	 {
	    if(bitnumber>UINTSIZE)
	      {
		 array_position++;
		 bitnumber=1;
	      }              
	    chrom[array_position]=chrom[array_position]>>1;
	    if(chrominfo.object[count1]>=(int) pow ((double) 2 , (double) (fieldlength-count2) ) )
	      {
		 chrom[array_position]=chrom[array_position]^leftmask;
		 chrominfo.object[count1]=chrominfo.object[count1]-(int) pow ( (double) 2, (double) (fieldlength-count2) );                 
	      }
	    bitnumber++;
	 }        

    }
   for(count1=0; count1<number_of_objects; count1++)
     {
	for(count2=1; count2<=fieldlength; count2++)
	  {
	    if(bitnumber>UINTSIZE)
	      {
		array_position++;
		bitnumber=1;
	      }                                            
	    chrom[array_position]=chrom[array_position]>>1;  
	    if(chrominfo.group[count1]>=(int) pow ( (double) 2, (double) (fieldlength-count2) ) )
	      {
		chrom[array_position]=chrom[array_position]^leftmask;
		chrominfo.group[count1]=chrominfo.group[count1] - (int) pow ( (double) 2, (double) (fieldlength-count2) );
	      }
	    bitnumber++;
	  }
     }
}  





/*
Does not pack the bits.  Uses more memory and less CPU.
*/
void make_binary(chrominfo, chrom)
  struct group_chrom chrominfo;
  unsigned *chrom;
{                                                    
  int count1;

  for (count1=0; count1<number_of_objects; count1++)
    {
      chrom[count1]=chrominfo.object[count1];
      chrom[count1+number_of_objects]=chrominfo.group[count1];
    }
}



struct group_chrom convert_from_binary(chrom)
unsigned *chrom;
{
  int count1;
  struct group_chrom chrominfo;
  
  for (count1=0; count1<number_of_objects; count1++)
    {
      chrominfo.object[count1]=chrom[count1];
      chrominfo.group[count1]=chrom[count1+number_of_objects];
    }                                            
  return chrominfo; 
}



struct group_chrom convert_from_binary2(chrom)
unsigned *chrom;
{               
  struct group_chrom chrominfo;
  int decimal_number;
  int bitnumber;
  int fieldnumber;
  int count1, count2;
  unsigned temp_chrom;
  unsigned one=1; 
  unsigned mask=1;

  decimal_number=0;
  bitnumber=1;
  fieldnumber=1;  
  for (count1=0; count1<chromsize; count1++)
    {
      temp_chrom=chrom[count1];
      for (count2=1; (count2<=UINTSIZE)&&(count2+count1*UINTSIZE<=lchrom*one); count2++)
	  {
	     if(bitnumber>fieldlength)
		{
		   if(fieldnumber<=number_of_objects)
		     {
			chrominfo.object[fieldnumber-1]=decimal_number;
		     }
		   else
		     {
			chrominfo.group[fieldnumber-number_of_objects-1] = decimal_number;
		     }
		  decimal_number=0;
		  bitnumber=1;   
		  fieldnumber++;
		}                   

	      decimal_number=decimal_number*2;
	      if(mask==(mask&temp_chrom))
		{
		   decimal_number++;
		}
	      temp_chrom=temp_chrom>>1;
	      bitnumber++;
	  } 
      } 
    chrominfo.group[fieldnumber-number_of_objects-1]=decimal_number;
    return chrominfo;
}



struct group_chrom rename_chrom(old)
struct group_chrom old;
{
  struct group_chrom new;
  int count1;
  int group; 
  int hash[TWICE_MAX_NUM_OF_OBJECTS];
  int temp;
  
  old.number_of_groups=determine_num_of_groups(old);

  temp=2*number_of_objects;
  for(count1=0; count1<temp; count1++)
    {
      hash[count1]=-1;
    }

  group=0;
  for(count1=0; count1<number_of_objects; count1++)
    {
       if(hash[old.object[count1]]==-1)
	 {
	   hash[old.object[count1]]=group;
	   new.object[count1]=group;
	   group++;
	 }
	else
	 {
	    new.object[count1]=hash[old.object[count1]];
	 }
     }


  for(count1=0; count1<old.number_of_groups; count1++)
    {
      new.group[count1]=hash[old.group[count1]];
    }
 
  return new;
} 



int determine_num_of_groups(chrominfo)
struct group_chrom chrominfo;
{
  int num_of_groups;
  int l[TWICE_MAX_NUM_OF_OBJECTS];
  int count1;
  int temp;
 
/* implementing a hash table to improve performance of this algorithm */

  temp=2*number_of_objects;
  for(count1=0; count1<temp; count1++)
    {
      l[count1]=0;
    }

  num_of_groups=0;
  for(count1=0; count1<number_of_objects; count1++)
    {
      if(l[chrominfo.object[count1]]==0)
	{
	  l[chrominfo.object[count1]]=1;
	  num_of_groups++;
	}
    }
   return num_of_groups;
}





void sortem_ascending(a,size,number)
int a[];
int size[];
int number;
{
  int count1, count2;
  int temp_int;
  int smallest, smallest_position;

  for(count1=0; count1<number-1; count1++)
    {         
       smallest=size[a[count1]];
       smallest_position=count1;

       for(count2=count1+1; count2<number; count2++)
	 {
	    if(size[a[count2]]<smallest)
	      {
		 smallest_position=count2;
		 smallest=size[a[count2]];
	      }
	 }
	    
       temp_int=a[smallest_position];
       a[smallest_position]=a[count1];
       a[count1]=temp_int;
    }            
}



/* 
Sort ascending, only 1 out of order. 
(More efficient than sorting whole list)
*/
void sortem_a(a,size,number)
int a[];
int size[MAX_NUM_OF_OBJECTS];
int number;

{
  int count1;
  int temp_int;
  
  for(count1=0; count1<number-1; count1++)
    {
      if(size[a[count1]]>size[a[count1+1]])
	    {
	      temp_int=a[count1];
	      a[count1]=a[count1+1];
	      a[count1+1]=temp_int;
    	}
    }
}



