/*
Header file for GGA
Last Modified 07/31/95
*/



#include <stdio.h>
#include "external.h"

#define MAX_NUM_OF_OBJECTS 10000       /* maximum number of objects */
#define TWICE_MAX_NUM_OF_OBJECTS  20000  /*  2 * max number of objects */

struct group_chrom
  {
    int number_of_groups;
    int object[MAX_NUM_OF_OBJECTS];
    int group[TWICE_MAX_NUM_OF_OBJECTS];
    int x1,x2;
  };


/*
Global Variables
*/  
extern int debug;
extern int number_of_objects;
extern int bin_size; /* For BBP */
extern int number_of_groups; /* For MMP */
extern int object_information[MAX_NUM_OF_OBJECTS];
extern int ff_ffd_bf;
extern char outfilename[30];



struct group_chrom application_dependent_initialize();
struct group_chrom application_dependent_reinsert();








/*
Converts from binary to struct group_chrom
*/
struct group_chrom convert_from_binary();



/*
Determines the number of groups
*/
int determine_num_of_groups(struct group_chrom);




/*
Returns the size of a group
*/
int determine_group_size(struct group_chrom);



/*
Determines the sizes of all groups
*/
void determine_group_sizes();


void make_binary();

/*
Prints a chromosome
*/
void print_chr();



struct group_chrom remove_objects_ff();


/* 
For use with MMP.  Reinserts objects from the queue using
Longest Job First 
*/
struct group_chrom remove_objects_ljf();


struct group_chrom rename_chrom();


void determine_percent_optimal();


void sortem_ascending();


void sortem_a();
